SystemOrganization addCategory: #Spotify!

Object subclass: #SpotifyApiCall
	instanceVariableNames: 'apiMethod queryString searchType returnFormat resultsCount resultsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spotify'!

!SpotifyApiCall methodsFor: 'accessing' stamp: 'SergioRuiz 9/8/2012 22:37'!
apiMethod
	^ apiMethod! !

!SpotifyApiCall methodsFor: 'accessing' stamp: 'SergioRuiz 9/8/2012 22:37'!
apiMethod: anObject
	apiMethod := anObject! !

!SpotifyApiCall methodsFor: 'returning' stamp: 'SergioRuiz 9/11/2012 00:58'!
createSpotifyTrack: trackDictionary 
	|spotifyTrack|
	
	spotifyTrack := SpotifyTrack new.
	spotifyTrack artist: (((trackDictionary at: 'artists') at: 1) at: 'name').
	spotifyTrack album: ((trackDictionary at: 'album') at: 'name').
	spotifyTrack title: (trackDictionary at: 'name').
	spotifyTrack href: (trackDictionary at: 'href').
	spotifyTrack spotifyData: trackDictionary .
	
	^ spotifyTrack ! !

!SpotifyApiCall methodsFor: 'private' stamp: 'SergioRuiz 9/10/2012 23:57'!
getQueryResults
	"comment stating purpose of message"
	|tracks  results|
	
	results := self queryUrl  asUrl retrieveContents contentStream.
	tracks := NeoJSONReader fromString: results.

	^ tracks! !

!SpotifyApiCall methodsFor: 'accessing' stamp: 'SergioRuiz 9/17/2012 00:26'!
initialize
	"comment stating purpose of message"
	super initialize.
	apiMethod  := 'search'.
	searchType := 'track'.
	queryString := 'initString'.
	returnFormat := 'json'.
	resultsList := OrderedCollection new.
	resultsCount := 0.
	^ self
! !

!SpotifyApiCall methodsFor: 'public-calls' stamp: 'SergioRuiz 9/9/2012 00:41'!
queryString
	^ queryString encodeForHTTP ! !

!SpotifyApiCall methodsFor: 'public-calls' stamp: 'SergioRuiz 9/8/2012 22:37'!
queryString: anObject
	queryString := anObject! !

!SpotifyApiCall methodsFor: 'setup' stamp: 'SergioRuiz 9/9/2012 01:07'!
queryUrl
	|url|
	
	url := 'http://ws.spotify.com/', apiMethod , '/1/', searchType, '.', returnFormat,  '?q=', self queryString.

	^ url! !

!SpotifyApiCall methodsFor: 'public-calls' stamp: 'SergioRuiz 9/9/2012 23:57'!
resultsCount
	^ resultsCount! !

!SpotifyApiCall methodsFor: 'public-calls' stamp: 'SergioRuiz 9/9/2012 23:57'!
resultsCount: anObject
	resultsCount := anObject! !

!SpotifyApiCall methodsFor: 'public-calls' stamp: 'SergioTRuiz 9/12/2012 16:38'!
resultsList
	|results spotifyResults tracks|
	
	spotifyResults := self getQueryResults.
	tracks := spotifyResults at: 'tracks'.
	results := tracks collect:  [:track | self createSpotifyTrack: track].
	self resultsCount: results size.
	
	^ results! !

!SpotifyApiCall methodsFor: 'accessing' stamp: 'SergioRuiz 9/8/2012 23:20'!
returnFormat
	^ returnFormat! !

!SpotifyApiCall methodsFor: 'accessing' stamp: 'SergioRuiz 9/8/2012 23:20'!
returnFormat: anObject
	returnFormat := anObject! !

!SpotifyApiCall methodsFor: 'accessing' stamp: 'SergioRuiz 9/8/2012 23:20'!
searchType
	^ searchType! !

!SpotifyApiCall methodsFor: 'accessing' stamp: 'SergioRuiz 9/8/2012 23:20'!
searchType: anObject
	searchType := anObject! !

Object subclass: #SpotifyTrack
	instanceVariableNames: 'title album artist href spotifyData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spotify'!

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
album
	^ album! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
album: anObject
	album := anObject! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
artist
	^ artist! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
artist: anObject
	artist := anObject! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/11/2012 00:53'!
href
	^ href! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/11/2012 00:52'!
href: anObject
	href := anObject! !

!SpotifyTrack methodsFor: 'public-interface' stamp: 'SergioRuiz 9/27/2012 01:21'!
selectLabel
	^ self artist , ' | ', self title, ' | ', self album! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/11/2012 00:58'!
spotifyData
	^ spotifyData! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/11/2012 00:58'!
spotifyData: anObject
	spotifyData := anObject! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
spotifyID
	^ spotifyID! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
spotifyID: anObject
	spotifyID := anObject! !

!SpotifyTrack methodsFor: 'public-interface' stamp: 'SergioRuiz 9/13/2012 01:00'!
spotifyPlayButton
	"Returns the html for a play button"
	|baseUrl|
	
	baseUrl := 'https://embed.spotify.com/'.
	
	^ '<iframe src="', baseUrl, '?uri=', self href, '" frameborder="0" allowTransparency="true"></iframe>'
	
	
	
	! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
title
	^ title! !

!SpotifyTrack methodsFor: 'accessing' stamp: 'SergioRuiz 9/9/2012 02:15'!
title: anObject
	title := anObject! !
